=== debian/changelog ===
zsv (1.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1119153)

 -- Azeem Sajid <azeem.sajid@gmail.com>  Tue, 17 Feb 2026 15:50:36 +0500
