=== debian/control ===
Source: zsv
Section: utils
Priority: optional
Maintainer: Azeem Sajid <azeem.sajid@gmail.com>
Build-Depends: debhelper-compat (= 13), libncurses-dev
Standards-Version: 4.7.2
Homepage: https://github.com/liquidaty/zsv
Vcs-Browser: https://github.com/liquidaty/zsv
Vcs-Git: https://github.com/liquidaty/zsv.git
Rules-Requires-Root: no

Package: zsv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tabular data swiss-army knife CLI
 zsv is a fast and extensible CLI utility for CSV data.
 It achieves high performance using SIMD operations,
 efficient memory use and other optimization techniques,
 and can also parse generic-delimited and fixed-width
 formats, as well as multi-row-span headers.

Package: zsv-dev
Architecture: any
Depends: ${misc:Depends}
Description: world's fastest (SIMD) CSV parser library
 zsv-dev contains the development files for the zsv
 library, which can be used to parse CSV and other
 tabular data formats in your own C programs.
