=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	./configure --prefix=$(CURDIR)/debian/tmp

override_dh_auto_build:

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_auto_install:
	$(MAKE) install

override_dh_auto_test:

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_clean:
	[ -f config.mk ] && $(MAKE) clean || echo 'No config.mk found, skipping clean'
