=== debian/watch ===
version=4
https://github.com/liquidaty/zsv/tags .*/v?(\d.*)@ARCHIVE_EXT@
